/*
 * Load.java
 *
 */

package matching;

import java.io.IOException;

import javax.swing.JFrame;
/*
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.io.PajekNetReader;
import edu.uci.ics.jung.visualization.PluggableRenderer;
import edu.uci.ics.jung.visualization.SpringLayout;
import edu.uci.ics.jung.visualization.VisualizationViewer;
*/
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

import edu.uci.ics.jung.graph.ArchetypeVertex;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.impl.SparseGraph;
import edu.uci.ics.jung.graph.Vertex;
import edu.uci.ics.jung.graph.decorators.DefaultToolTipFunction;
import edu.uci.ics.jung.graph.decorators.EdgeShape;
import edu.uci.ics.jung.graph.decorators.EllipseVertexShapeFunction;
import edu.uci.ics.jung.graph.decorators.PickableVertexPaintFunction;
import edu.uci.ics.jung.graph.decorators.VertexIconAndShapeFunction;
import edu.uci.ics.jung.graph.decorators.VertexStringer;
import edu.uci.ics.jung.graph.impl.DirectedSparseEdge;
import edu.uci.ics.jung.graph.impl.DirectedSparseGraph;
import edu.uci.ics.jung.graph.impl.SparseVertex;
import edu.uci.ics.jung.visualization.DefaultGraphLabelRenderer;
import edu.uci.ics.jung.visualization.FRLayout;
import edu.uci.ics.jung.visualization.GraphZoomScrollPane;
import edu.uci.ics.jung.visualization.PluggableRenderer;
import edu.uci.ics.jung.visualization.ShapePickSupport;
import edu.uci.ics.jung.visualization.VisualizationViewer;
import edu.uci.ics.jung.visualization.control.CrossoverScalingControl;
import edu.uci.ics.jung.visualization.control.DefaultModalGraphMouse;
import edu.uci.ics.jung.visualization.control.ModalGraphMouse;
import edu.uci.ics.jung.visualization.control.ScalingControl;

import edu.uci.ics.jung.utils.UserData;


/** Load graph
 *  1. test from Java source (now)
 *  2. from the database (todo)
 */
public class Load {

    private Graph       graph;
    private Vertex[]    vertices;
    /** the visual component and renderer for the graph */
    VisualizationViewer vv;
    
    /** whether to show the node labels in editor */
    boolean showLabels;
    
    /** List of vertices of the source graph to be compared */
    private List<Vertex> sub_graph1;
    /** List of vertices of the destination graph to be compared */
    private List<Vertex> sub_graph2;
    
    public List<Vertex> getSubGraph1() { return sub_graph1; }
    public List<Vertex> getSubGraph2() { return sub_graph2; }
    
    public Graph loadFromWebDeso() {
        sub_graph1 = null;
        sub_graph2 = null;
        
        // todo loading from database
        // ...
        
        return null;
    }
    
    /*
    public Graph loadTestStaticGraph() {
        graph = new SparseGraph();
        vertices = createTestVertices(5*2);
        createTestEdges(vertices);
        return graph;
    }
        
    public void draw() {
        PluggableRenderer pr = new PluggableRenderer();
        pr.setVertexStringer(new UnicodeVertexStringer());
        pr.setVertexPaintFunction(new PickableVertexPaintFunction(pr, Color.lightGray, Color.white,  Color.yellow));
        pr.setGraphLabelRenderer(new DefaultGraphLabelRenderer(Color.cyan, Color.cyan));
        VertexIconAndShapeFunction dvisf =
            new VertexIconAndShapeFunction(new EllipseVertexShapeFunction());
        pr.setVertexShapeFunction(dvisf);
        pr.setVertexIconFunction(dvisf);
        loadImages(vertices, dvisf.getIconMap());
        vv =  new VisualizationViewer(new FRLayout(graph), pr);
        vv.setPickSupport(new ShapePickSupport());
        pr.setEdgeShapeFunction(new EdgeShape.QuadCurve());
        vv.setBackground(Color.white);

        // add my listener for ToolTips
        vv.setToolTipFunction(new DefaultToolTipFunction());
        
        // create a frame to hold the graph
        final JFrame frame = new JFrame();
        Container content = frame.getContentPane();
        final GraphZoomScrollPane panel = new GraphZoomScrollPane(vv);
        content.add(panel);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        final ModalGraphMouse gm = new DefaultModalGraphMouse();
        vv.setGraphMouse(gm);
        
        final ScalingControl scaler = new CrossoverScalingControl();

        JButton plus = new JButton("+");
        plus.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                scaler.scale(vv, 1.1f, vv.getCenter());
            }
        });
        JButton minus = new JButton("-");
        minus.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                scaler.scale(vv, 0.9f, vv.getCenter());
            }
        });

        JCheckBox lo = new JCheckBox("Show Labels");
        lo.addItemListener(new ItemListener(){
            public void itemStateChanged(ItemEvent e) {
                showLabels = e.getStateChange() == ItemEvent.SELECTED;
                vv.repaint();
            }
        });
        lo.setSelected(true);
        
        JPanel controls = new JPanel();
        controls.add(plus);
        controls.add(minus);
        controls.add(lo);
        controls.add(((DefaultModalGraphMouse) gm).getModeComboBox());
        content.add(controls, BorderLayout.SOUTH);

        frame.pack();
        frame.setVisible(true);
    }
    */
    
    /**
     * create some vertices
     * @param count how many to create
     * @return the Vertices in an array
     */
    /*
    private Vertex[] createTestVertices(int count) {
        String[] labels = {
            // 0-4 vertices
            "Thing",
            "Supplier",
            "Hardware",
            "Furniture",
            "Mobile-Phone",
            // 5-9 vertices
            "Thing",
            "Provider",
            "Computer",
            "Furniture",
            "Smartphone",
        };
        sub_graph1 = new ArrayList();
        sub_graph2 = new ArrayList();
        Vertex[] v = new Vertex[count];
        for (int i = 0; i < count; i++) {
            //v[i] = graph.addVertex(new DirectedSparseVertex());
            v[i] = graph.addVertex(new SparseVertex());
            v[i].addUserDatum(SimVertConnectByEdge.NAME_KEY, labels[i], UserData.SHARED);
            
            Object tmp = (i < 5) ? sub_graph1.add(v[i]) : sub_graph2.add(v[i]);
        }
        return v;
    }*/

    /**
     * create edges for this demo graph
     * @param v an array of Vertices to connect
     */
    /*
    void createTestEdges(Vertex[] v) {
        // 0-4 first graph
        graph.addEdge(new DirectedSparseEdge(v[0], v[1]));
        graph.addEdge(new DirectedSparseEdge(v[1], v[2]));
        graph.addEdge(new DirectedSparseEdge(v[1], v[3]));
        graph.addEdge(new DirectedSparseEdge(v[2], v[4]));
        
        // 5-9 second graph
        graph.addEdge(new DirectedSparseEdge(v[5], v[6]));
        graph.addEdge(new DirectedSparseEdge(v[6], v[7]));
        graph.addEdge(new DirectedSparseEdge(v[6], v[8]));
        graph.addEdge(new DirectedSparseEdge(v[7], v[9]));
    }

    private void loadImages(Vertex[] vertices, Map imageMap) {
        
        ImageIcon icon_class = null;
        ImageIcon icon_attr = null;
        try {
            icon_class  = new ImageIcon(getClass().getResource("/class.png"));
            icon_attr   = new ImageIcon(getClass().getResource("/attr.png"));
        } catch(Exception ex) {
            System.err.println("You need class_icons.jar in your classpath to see the class, attribute icons.");
        }
        
        for(Vertex v:vertices) {
            imageMap.put(v,icon_class);
        }
    }*/
    
    public static void main(String[] args) 
    {
        Load l = new Load();
        //l.loadTestStaticGraph();
        l.loadFromWebDeso();
        //l.draw();
    }
}
