/*
 * UnicodeEdgeStringer.java
 *
 * This software is open-source under the BSD license; see either
 * "license.txt" or http://jung.sourceforge.net/license.txt for a description.
 */

package matching;

import edu.uci.ics.jung.graph.decorators.EdgeStringer;
import edu.uci.ics.jung.graph.ArchetypeEdge;
import edu.uci.ics.jung.graph.Edge;


public class UnicodeEdgeStringer implements EdgeStringer {

    /** whether to show the edge labels in editor */
    private boolean showLabels;
  
    /** whether to show the edge labels in editor */
    public void setShowLabels(boolean b_showLabels) {
        showLabels = b_showLabels;
    }

    public UnicodeEdgeStringer() {
        showLabels = true;
    }
        
    public String getLabel(ArchetypeEdge e) {
        if(showLabels && e.containsUserDatumKey(GraphComparator.SIM_KEY)) {
            //return "tempo";
                Double d = (Double)e.getUserDatum(GraphComparator.SIM_KEY);
                System.out.println(d);
                return d.toString();
        } else {
            return "";
        }
    }
    
}