/*
 * UnicodeVertexStringer.java - allows to draw unicode symbolas 
 *  as labels of vertices.
 *
 * This software is open-source under the BSD license; see either
 * "license.txt" or http://jung.sourceforge.net/license.txt for a description.
 */

package matching;

import java.util.HashMap;
import java.util.Map;
import edu.uci.ics.jung.graph.decorators.VertexStringer;
import edu.uci.ics.jung.graph.ArchetypeVertex;
import edu.uci.ics.jung.graph.Vertex;
import javax.swing.Icon;

public class UnicodeVertexStringer implements VertexStringer {
    
    /** whether to show the node labels in editor */
    private boolean showLabels;
    
    Map iconMap = new HashMap();
    
    /** whether to show the node labels in editor */
    public void setShowLabels(boolean b_showLabels) {
        showLabels = b_showLabels;
    }
    
    public UnicodeVertexStringer() {
        showLabels = true;
    }

    /* (non-Javadoc)
     * @see edu.uci.ics.jung.graph.decorators.VertexStringer#getLabel(edu.uci.ics.jung.graph.Vertex)
     */
    public String getLabel(ArchetypeVertex v) {
        if(showLabels) {
            return (String)v.getUserDatum(GraphComparator.NAME_KEY);
        } else {
            return "";
        }
    }

    public Icon getIcon(Vertex v) {
        return (Icon)iconMap.get(v);
    }
}
