package matching;

import junit.framework.*;
import edu.uci.ics.jung.utils.UserData;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.impl.SparseGraph;
import edu.uci.ics.jung.graph.impl.SparseVertex;
import edu.uci.ics.jung.graph.impl.UndirectedSparseEdge;
import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.Element;
import edu.uci.ics.jung.graph.Vertex;

import edu.uci.ics.jung.utils.UserData;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.impl.SparseGraph;
import edu.uci.ics.jung.graph.impl.SparseVertex;
import edu.uci.ics.jung.graph.impl.UndirectedSparseEdge;
import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.Element;
import edu.uci.ics.jung.graph.Vertex;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import edu.uci.ics.jung.algorithms.importance.*;

import edu.uci.ics.jung.utils.MutableDouble;
import edu.uci.ics.jung.utils.UserData;

import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.Element;
import edu.uci.ics.jung.graph.Vertex;
import edu.uci.ics.jung.graph.ArchetypeVertex;
import edu.uci.ics.jung.graph.decorators.DefaultToolTipFunction;
import edu.uci.ics.jung.graph.decorators.EdgeShape;
import edu.uci.ics.jung.graph.decorators.PickableEdgePaintFunction;
import edu.uci.ics.jung.graph.decorators.EllipseVertexShapeFunction;
import edu.uci.ics.jung.graph.decorators.PickableVertexPaintFunction;
import edu.uci.ics.jung.graph.decorators.VertexIconAndShapeFunction;
import edu.uci.ics.jung.graph.decorators.VertexStringer;
import edu.uci.ics.jung.graph.impl.UndirectedSparseEdge;
import edu.uci.ics.jung.graph.impl.DirectedSparseEdge;
import edu.uci.ics.jung.graph.impl.DirectedSparseGraph;
import edu.uci.ics.jung.graph.impl.DirectedSparseVertex;
import edu.uci.ics.jung.visualization.DefaultGraphLabelRenderer;
import edu.uci.ics.jung.visualization.FRLayout;
import edu.uci.ics.jung.visualization.GraphZoomScrollPane;
import edu.uci.ics.jung.visualization.PluggableRenderer;
import edu.uci.ics.jung.visualization.ShapePickSupport;
import edu.uci.ics.jung.visualization.VisualizationViewer;
import edu.uci.ics.jung.visualization.control.CrossoverScalingControl;
import edu.uci.ics.jung.visualization.control.DefaultModalGraphMouse;
import edu.uci.ics.jung.visualization.control.ModalGraphMouse;
import edu.uci.ics.jung.visualization.control.ScalingControl;

import java.util.ArrayList;
import java.util.Map;

public class GraphCreatorTest extends TestCase {

    /** the visual component and renderer for the graph */
    VisualizationViewer vv;

    /** Whether to enable visual effects (e.g. draw edge labels) if true,
     * skip all visual functions if only calculations to be done. */
    public boolean enable_visual;
    
    UnicodeVertexStringer   u_vertexstringer;
    UnicodeEdgeStringer     u_edgestringer;
    
    public Graph    graph1;
    public Graph    graph2;
    public Graph    graph12;
    
    public GraphCreatorTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        GraphCreator g = new GraphCreator();
        graph1 = g.createGraph(g.labels1, g.edges1);
        graph2 = g.createGraph(g.labels2, g.edges2);
        graph12 = g.addGraph(graph1, g.labels2, g.edges2);
    }

    protected void tearDown() throws Exception {
    }

    public static Test suite() {
        TestSuite suite = new TestSuite(GraphCreatorTest.class);
        
        return suite;
    }

    /**
     * Test of createGraph method, of class matching.GraphCreator.
     */
    public void testCreateGraph() {
        System.out.println("createGraph");
        
        GraphCreator g = new GraphCreator();
        enable_visual = true;
        Graph g1 = g.createGraph(  g.labels1, g.edges1);
        Graph g12 = g.addGraph(g1, g.labels2, g.edges2);
        //Graph g3 = join(Graph g1, Graph g2);
        draw(g12);
        int i = 1;
        //while(i>0) {
            i = 1;
        //};
    }
    
    
    /**
     * Test of addGraph method, of class matching.GraphCreator.
     */
    /*public void testAddGraph() {
        System.out.println("addGraph");
        
        Graph g = null;
        String[] labels = null;
        int[][] edges = null;
        GraphCreator instance = new GraphCreator();
        
        Graph expResult = null;
        Graph result = instance.addGraph(g, labels, edges);
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }*/
    
    
    
    private void loadImages(Vertex[] vertices, Map imageMap) {
        
        ImageIcon icon_class = null;
        ImageIcon icon_attr = null;
        try {
            icon_class  = new ImageIcon(getClass().getResource("/class.png"));
            icon_attr   = new ImageIcon(getClass().getResource("/attr.png"));
        } catch(Exception ex) {
            System.err.println("You need class_icons.jar in your classpath to see the class, attribute icons.");
        }
        
        for(Vertex v:vertices) {
            imageMap.put(v,icon_class);
        }
    }
        
    public void draw(Graph graph)
    {   
        Vertex[] v = (Vertex[])(graph.getVertices()).toArray(new Vertex[0]);
        
        PluggableRenderer pr = new PluggableRenderer();
        u_vertexstringer = new UnicodeVertexStringer();
        pr.setVertexStringer(u_vertexstringer);
        pr.setVertexPaintFunction(new PickableVertexPaintFunction(pr, Color.lightGray, Color.white,  Color.yellow));
        pr.setGraphLabelRenderer(new DefaultGraphLabelRenderer(Color.cyan, Color.cyan));
        VertexIconAndShapeFunction dvisf =
            new VertexIconAndShapeFunction(new EllipseVertexShapeFunction());
        pr.setVertexShapeFunction(dvisf);
        pr.setVertexIconFunction(dvisf);
        loadImages(v, dvisf.getIconMap());
        vv =  new VisualizationViewer(new FRLayout(graph), pr);
        vv.setPickSupport(new ShapePickSupport());
        pr.setEdgeShapeFunction(new EdgeShape.QuadCurve());
        vv.setBackground(Color.white);
        
        u_edgestringer = new UnicodeEdgeStringer ();
        pr.setEdgeStringer(u_edgestringer);
        //pr.setEdgePaintFunction(new PickableEdgePaintFunction(pr, Color.black, Color.cyan));

        // add my listener for ToolTips
        vv.setToolTipFunction(new DefaultToolTipFunction());
        
        // create a frome to hold the graph
        final JFrame frame = new JFrame();
        Container content = frame.getContentPane();
        final GraphZoomScrollPane panel = new GraphZoomScrollPane(vv);
        content.add(panel);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        final ModalGraphMouse gm = new DefaultModalGraphMouse();
        vv.setGraphMouse(gm);
        
        final ScalingControl scaler = new CrossoverScalingControl();

        JButton plus = new JButton("+");
        plus.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                scaler.scale(vv, 1.1f, vv.getCenter());
            }
        });
        JButton minus = new JButton("-");
        minus.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                scaler.scale(vv, 0.9f, vv.getCenter());
            }
        });

        JCheckBox lo = new JCheckBox("Show Node Labels");
        lo.addItemListener(new ItemListener(){
            public void itemStateChanged(ItemEvent e) {
                u_vertexstringer.setShowLabels(e.getStateChange() == ItemEvent.SELECTED);
                vv.repaint();
            }
        });
        lo.setSelected(true);
        
        JCheckBox loe = new JCheckBox("Show Edge Labels");
        loe.addItemListener(new ItemListener(){
            public void itemStateChanged(ItemEvent e) {
                u_edgestringer.setShowLabels(e.getStateChange() == ItemEvent.SELECTED);
                vv.repaint();
            }
        });
        loe.setSelected(true);
        
        JPanel controls = new JPanel();
        controls.add(plus);
        controls.add(minus);
        controls.add(lo);
        controls.add(loe);
        controls.add(((DefaultModalGraphMouse) gm).getModeComboBox());
        content.add(controls, BorderLayout.SOUTH);

        frame.pack();
        frame.setVisible(true);
    }
    
}
